#include <bits/stdc++.h>
using namespace std;


void put_to_start(int i);

vector<int> A;

void put_to_start_and_update(int i){
    if(i & (i + 1))
        throw "i should be 2^k - 1";
    
    int tmp = A[i];
    for(int j = i; j > 0; j--)
        A[j] = A[j - 1];
    A[0] = tmp;
    put_to_start(i + 1);
}

// Розділити масив таким чином, щоб у лівій частині не було
// елементу більше, ніж у лівій.


void divide(int n) {
    int nhalf = n / 2;
    vector<int>::iterator it = A.begin();
    int mx_el_r = *max_element(it + nhalf, it + n);
    int mn_el_l = *min_element(it, it + nhalf);
    
    vector<int> B = A;
    nth_element(B.begin(), B.begin() + n/2, B.begin() + n);
    int first_element_of_second_half = B[n/2];
    
    while(mx_el_r > mn_el_l){
        if(A[n / 2 - 1] < first_element_of_second_half)
            put_to_start_and_update
            (n - 1);
        else
            put_to_start_and_update
            (n/2 - 1);
        mx_el_r = *max_element(it + nhalf, it + n);
        mn_el_l = *min_element(it, it + nhalf);
    }
}


void swap_halves(int n){
    for(int i = n/2; i > 0; i--)
        put_to_start(n);
    
    // Оновлюємо стан масиву А
    vector<int> tmp(n / 2);
    for(int i = n/2; i < n; i++){
        tmp[i - n/2] = A[i];
        A[i] = A[i - n/2];
    }
    for(int i = 0; i < n/2; i++)
        A[i] = tmp[i];
}

void solve(int n){
    if(n == 1)
        return;
    divide(n);
    solve(n / 2);
    swap_halves(n);
    solve(n / 2);
}

vector<int> make_different(vector<int> a){
    map<int, vector<int> > pos;
    for(int i = 0; i < a.size(); i++)
        pos[a[i]].push_back(i);
    int cnt = 0;
    for(auto & p : pos)
        for(auto pp : p.second)
            a[pp] = cnt++;
    return a;
}

void solve(int n, vector<int> a, int block){
    A = make_different(a);
    solve(n);
}


vector<int> ANSWER;

void put_to_start(int i){
    ANSWER.push_back(i);
}

int main(){
    ifstream cin("sort.in");
    ofstream cout("sort.out");
    
    int n, block;
    cin >> n >> block;
    vector<int> a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];
    
    solve(n, a, block);
    
    cout << ANSWER.size() << '\n';
    for(int i = 0; i < (int)ANSWER.size(); i++)
        cout << ANSWER[i] << ' ';
    cout << '\n';
}
