#include <bits/stdc++.h>

using namespace std;

const int max_n = 1000111;
const int max_m = 20;

int A, B, C, subtask;
int n, m, c[max_m], masks[max_n], common[1 << max_m];
long long dp[1 << max_m];
long long sum_odd[1 << max_m];
long long sum_even[1 << max_m];
char z[1 << max_m];
vector<int> a[max_m];

int f(long long e) {
    e %= n;
    return (A * e * e + B * e + C) % n;
}

bool get_bit(int mask, int pos) {
    return (bool) (mask & (1 << pos));
}

long long cn2(long long n) {
    return (n * (n - 1)) / 2;
}

void get_all_common() {
    for (int i = 0; i < m; ++i) {
        for (int x : a[i]) {
            masks[x] |= (1 << i);
        }
    }
    for (int i = 1; i <= n; ++i) {
        ++common[masks[i]];
    }
    for (int b = m - 1; b >= 0; --b) {
        for (int mask = 0; mask < (1 << m); ++mask) {
            if (get_bit(mask, b)) {
                common[mask ^ (1 << b)] += common[mask];
            }
        }
    }
}

long long solve_ok() {
    get_all_common();
    
    for (int mask = 0; mask < (1 << m); ++mask) {
        int z = 0;
        for (int i = 0; i < m; ++i) {
            z ^= get_bit(mask, i);
        }
        if (z) {
            sum_odd[mask] = cn2(common[mask]);
        } else {
            sum_even[mask] = cn2(common[mask]);
        }
    }
    for (int nxt = 0; nxt < m; ++nxt) {
        for (int mask = 0; mask < (1 << m); ++mask) {
            if (!get_bit(mask, nxt)) {
                sum_odd[mask | (1 << nxt)] += sum_odd[mask];
                sum_even[mask | (1 << nxt)] += sum_even[mask];
            }
        }
    }
    
    for (int mask = 0; mask < (1 << m); ++mask) {
        for (int nxt = 0; nxt < m; ++nxt) {
            if (!get_bit(mask, nxt)) {
                long long add = sum_odd[mask | (1 << nxt)] - sum_even[mask | (1 << nxt)];
                add -= sum_odd[mask] - sum_even[mask];
                dp[mask | (1 << nxt)] = max(dp[mask | (1 << nxt)], dp[mask] + 1LL * f(add) * c[nxt]);
            }
        }
    }
    return dp[(1 << m) - 1];
}

int main() {
    freopen("air.in", "r", stdin);
    freopen("air.out", "w", stdout);
    scanf("%d%d%d", &n, &m, &subtask);
    scanf("%d%d%d", &A, &B, &C);
    for (int i = 0; i < m; ++i) {
        scanf("%d", &c[i]);
    }
    for (int i = 0; i < m; ++i) {
        int k;
        scanf("%d", &k);
        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            scanf("%d", &a[i][j]);
        }
    }
    long long ans = solve_ok();
    printf("%lld\n", ans);
    return 0;
}
